#include <iostream>
#include <math.h>

using namespace std;

int main()
{
    long long int n, k, r=0;
    cin>>n>>k;
    long long int a[n];
    for(long long int i=0;i<n;i++)
        cin>>a[i];

    if(k==0)
        for(long long int i=0;i<n;i++)
            r+= a[i];
    else
        for(long long int i=0;i<n;i++)
            r += a[i]*(((n-i)*(i+1)));

    long long int p = pow(10, 9) + 7;
    r = r % p;
    cout<<r;
    return 0;
}